#include "encoder.h"
#include "fx2.h"
#include "fx2regs.h"
#include "fx2sdly.h"

#define ENCODER_N 5

void Write_Seg_LED (BYTE);
void initialize_encoder();
void Encoder_Write(WORD addr, WORD reg, WORD len, WORD Data);
BYTE Encoder_Read(WORD addr, WORD reg);
void Encoder_LED(WORD addr, BOOL direction);
BYTE encoder[ENCODER_N] = {0x30, 0x31, 0x32, 0x33, 0x34}; 																													//Encoder Address 

WORD counter[ENCODER_N]  = {0,0,0,0,0}; //{0x38B0, 0x4364, 0xFFFF, 0x0C55, 0xFFFF};																																		//Encoder default counter value

BOOL ENCODER_RDY = FALSE;

void initialize_encoder()
{
		int i, ii, iii;
		BYTE Status;
		
		ii = 0;
		iii =1;
//Reset the FIFO
		FIFORESET = 0x80;
		SYNCDELAY;
		FIFORESET = 0x02;
		SYNCDELAY;
		FIFORESET = 0x00;
		SYNCDELAY;
//Fill EP0BUF with Setup contents
		EP0BUF[0] = 0x00; 		//Register to Start
		EP0BUF[1] = 0x0B; 		//General Config
		EP0BUF[2] = 0x00;			//Status
		EP0BUF[3] = 0x00;			//Counter Byte 4
		EP0BUF[4] = 0x00; 		//Counter Byte 3
		EP0BUF[5] = 0x00; 		//Counter Byte 2
		EP0BUF[6] = 0x00;			//Counter Byte 1
		EP0BUF[7] = 0x00; 		//Max Byte 4
		EP0BUF[8] = 0x00; 		//Max Byte 3
		EP0BUF[9] = 0x00;			//Max Byte 2
		EP0BUF[10] = 0x14; 		//Max Byte 1
		EP0BUF[11] = 0xFF;		//Min Byte 4
		EP0BUF[12] = 0xFF;		//Min Byte 3
		EP0BUF[13] = 0xFF;		//Min Byte 2
		EP0BUF[14] = 0xEC;		//Min Byte 1
		EP0BUF[15] = 0x00;		//LED A
		EP0BUF[16] = 0x00;		//LED B
		for (i=0; i < ENCODER_N; i++){		
			EZUSB_WriteI2C(encoder[i], 17, &EP0BUF);
			EZUSB_Delay(5);
			Status = Encoder_Read(encoder[i], ENCODER_STATUS);
			
			EP2FIFOBUF[ii] = LSB(counter[i]);
			EP2FIFOBUF[iii] = MSB(counter[i]);
			ii = ii + 2;
			iii = iii + 2;
		}
		for (i=10;i<16;i++){
			EP2FIFOBUF[i]=0xFF;
		}
		ENCODER_RDY = TRUE;
}
void Encoder_Write(WORD addr, WORD reg, WORD len, WORD Data)
{
			int i;
			BYTE xdata Encoder_Data[ENCODER_N];
			
			for(i=0;i<5;i++)
			{
				Encoder_Data[i]=0x00;
			}
			Encoder_Data[0] = reg;
			if (Data > 0x7F){
				for(i=1 ;i<4 ;i++)
				{
					Encoder_Data[i] = 0xFF;
				}
				Encoder_Data[4] = Data & 0xFF;
			}
			else
			{
				Encoder_Data[len - 1] = Data;
			}
			EZUSB_WriteI2C(addr , len, (WORD)Encoder_Data);					//write the data
			EZUSB_Delay(5);
}
BYTE Encoder_Read(WORD addr, WORD reg)
{
			BYTE xdata Encoder_Data[ENCODER_N];
			BOOL Stats;
	
			Encoder_Data[0] = reg;
			Stats = EZUSB_WriteI2C(addr, 1, (WORD)Encoder_Data);						//set the correct register to read from
			EZUSB_Delay(5);
			Stats = EZUSB_ReadI2C(addr, 1, (WORD)Encoder_Data);								//read register
			EZUSB_Delay(5);
			return(Encoder_Data[0]);
}

void Encoder_LED(WORD addr, BOOL direction)
{
		
		if(direction)
			{
				Encoder_Write(addr, 0x0F, 2, 0xFF);
				EZUSB_Delay(50);
				Encoder_Write(addr, 0x0F, 2, 0x00);
			}
			else
			{
				Encoder_Write(addr, 0x0E, 0x02, 0xFF);
				EZUSB_Delay(50);
				Encoder_Write(addr, 0x0E, 0x02, 0x00);
			}
			EZUSB_Delay(5);
}